/******************************************************************************/
/*  Wireless Temp/Humidity Logger                                             */
/*  Reciever unit rtc program                                                 */
/*  Copyright(c) 2013 Hirofumi Momose  hirofumi[at]momose.com                 */
/******************************************************************************/

#include <xc.h>
#include "daytime.h"

struct daytime_st daytime = {13, 01, 01, 00, 00, 00};
unsigned long epoch = 1000;

const unsigned char daymonth[] = {00, 31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31};

void daytime_set(struct daytime_st *set)
{
    INTCONbits.GIE = 0;
    daytime = *set;
    INTCONbits.GIE = 1; 
}

void daytime_update(void)
{
    epoch++;
    if(daytime.sec == 59){
        daytime.sec = 0;
        if(daytime.min == 59){
            daytime.min = 0;
            if(daytime.hour == 23){
                daytime.hour = 0;
                if(daytime.day == daymonth[daytime.mon]){
                    daytime.day = 1;
                    if(daytime.mon == 12){
                        daytime.mon = 1;
                        daytime.year ++;
                    } else {
                        daytime.mon++;
                    }
                } else {
                    daytime.day++;
                }
            } else {
                daytime.hour++;
            }
        } else {
            daytime.min++;
        }
    } else {
        daytime.sec++;
    }
}
// EOF
