/*******************************************************************
 * Wireless data logger
 * Copyright(c) 2013 H.Momose hirofumi@momose.com
 * Partly from picfun.com
 *******************************************************************/
#ifndef __GLCD_H__
#define __GLCD_H__

// function prototypes

void glcd_backlight(char bright);
void glcd_cmd(char cmd);
void glcd_write(char data);
char glcd_read(void);
void glcd_init(void);
void glcd_clear(char data);
void glcd_pixel(int Xpos, int Ypos, char On);
void glcd_line(int x0, int y0, int x1, int y1);
void glcd_char(char line, char colum, int letter);
void glcd_char1(char line, char colum, int letter);
void glcd_str(char line, char colum, char *s);
void glcd_image(char *ptr);

void glcd_cursor(char row, char col);
void glcd_putc(char letter);
void glcd_putc16(char letter);
void glcd_puts(const char *str);
void glcd_puts16(const char *str);

void glcd_reverse(char row, char col, char width);
void glcd_puticon(char icon);

#define ICON_NON    0
#define ICON_ANT    1
#define ICON_SPK    2
#define ICON_SDC    3
#define ICON_BAT    4
#define ICON_BEL    5

#endif // __GLCD_H__
