/*******************************************************************
 * Wireless data logger
 * Copyright(c) 2013 H.Momose hirofumi@momose.com
 *******************************************************************/
#ifndef __RX_H__
#define	__RX_H__

#define TMR3CLK         1500000L
#define MSEC2TMR3(x)    (unsigned short)(TMR3CLK*(x)/1000L)
#define USEC2TMR3(x)    (unsigned short)(TMR3CLK/1000L*(x)/1000L)

// Consideration of macro above
// TMR3 is short width must be below 65535 and
// any calculation intermediate value must not exceed 2^32
// MSEC2TMR3(1) ==> 1500
// USEC2TMR3(1) ==> 1.5
// USEC2TMR3(x)  x < 28630 is must.

//#define BIT_PERIOD_MAX  MSEC2TMR3(12)
//#define BIT_PERIOD_TYP  MSEC2TMR3(10)
//#define BIT_PERIOD_MIN  MSEC2TMR3(8)

#define BIT_PERIOD_MAX  USEC2TMR3(4800)
#define BIT_PERIOD_TYP  USEC2TMR3(4000)
#define BIT_PERIOD_MIN  USEC2TMR3(3200)


#define MAX_PREAMBLE_BITS 10

union data_u {
    struct {
        unsigned char data[3];
        unsigned vbatt :4;
        unsigned id :4;
    };
    struct {
        unsigned char c1, c2, c3, c4;
    };
    unsigned long uldata;
};

#define NO_DATA (0xffffffff)

/* Stat counter */
struct stat_count_st {
    unsigned long good;
    unsigned long sumerr;
    unsigned long premature;
    unsigned long overflow;
};
extern struct stat_count_st stat_count;

/* Debug state counter*/
struct state_count_st {
    unsigned long st0, st1, st2, st3;
};
extern struct state_count_st state_count;

/* Function prototypes */
void rx_init(void);
void rx_int(void);
unsigned long rx_getdata(void);

#endif	/* __RX_H__ */
